#include <cstdio>
#include <cmath>
#include <map>
#include <vector>
#include <queue>
#include <string>

using namespace std;
#define INF INFINITY

vector< vector<long double> > V;
/*int f(int where, int from, int i)
{
	long long double e;
	int k, r;
	while (!neigh[where].empty()){
		k = neigh[where].front();
		neigh[where].pop();
		e = E[where].front();
		E[where].pop();
		e += P[where];
		//cerr<<e<<' '<<P[k]<<' '<<k<<' '<<V[k]<<' '<<i<<endl;
		if (V[k] != 0){
			if (V[k] != i) continue;
			if (P[k] < e) return 1;
			else continue;
		}
		if (k == from) continue;
		P[k] = e;
		V[k] = i;
		r = f(k, where, i);
		if (r==1) return 1;
	}
	return 0;
}*/

int main()
{
	int C, R, i, j, k, l1, l2, a, b;
	map<string, int> M;
	vector< vector<bool> > B;

	char s[4], s2[4];
	while (1){
		scanf("%d", &C);
		if (C == 0) return 0;
		for (i=0; i<C; ++i){
			scanf("%s", s);
			M[s] = i;
		}
		V.resize(0);
		V.resize(C);
		B.resize(0);
		B.resize(C);
		for (i=0; i<C; ++i) V[i].resize(C, INF);
		for (i=0; i<C; ++i) V[i][i] = 0;
		for (i=0; i<C; ++i) B[i].resize(C, 0);
		for (i=0; i<C; ++i) B[i][i] = 1;

		scanf("%d", &R);
		for (i=0; i<R; ++i){
			scanf("%s %s %d:%d", s, s2, &a, &b);
			l1 = M[s];
			l2 = M[s2];
			V[l1][l2] = log((long double) a) - log((long double) b);
			B[l1][l2] = 1;
		}

		for (i=0; i<C; ++i){
			for (j=0; j<C; ++j){
				for (k=0; k<C; ++k){
					if (B[i][k] == 1 && B[k][j] == 1 && V[i][k] + V[k][j] < V[i][j]){
						V[i][j] = V[i][k] + V[k][j];
						B[i][j] = 1;
					}
				}
			}
		}
		for (i=0; i<C; ++i) if (V[i][i] < 0) break;
		if (i<C) printf("Arbitrage\n");
		else printf("Ok\n");
	}

	return 0;
}
